SystemOrganization addCategory: #'AL-HtmlApp-Core'!

ALInputTag subclass: #ALAppInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppInputTag methodsFor: 'accessing' stamp: 'cwp 9/20/2011 11:39'!
callback: aValuable
	self name: (canvas currentForm registerCallback: aValuable) asString
! !

Object subclass: #ALForm
	instanceVariableNames: 'callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALForm methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 15:58'!
appyData: data
	data do: 
		[ :ea || index |
		index := ea key asNumber.
		(callbacks at: index) value: ea value]! !

!ALForm methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 10:43'!
initialize
	callbacks := #().! !

!ALForm methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 10:44'!
registerCallback: aValuable
	callbacks := callbacks copyWith: aValuable.
	^ callbacks size.! !

ALATag subclass: #ALAppATag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppATag methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 11:40'!
callback: aValuable
	| path |
	path := canvas context registerCallback: aValuable.
	self href: path asString
! !

!ALAppATag methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 23:04'!
linkTo: aResource
	| path |
	path := canvas context registerResource: aResource.
	self href: path asString
	
! !

!ALAppATag methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 11:41'!
navigate: aValuable
	| path |
	path := canvas context registerNavigation: aValuable.
	self href: path asString
	
! !

ALHtml5Canvas subclass: #ALAppHtml5Canvas
	instanceVariableNames: 'context form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppHtml5Canvas class methodsFor: 'instance creation' stamp: 'cwp 9/19/2011 17:10'!
context: aContext stream: aWriteStream
	^ self basicNew
		initializeWithContext: aContext stream: aWriteStream! !

!ALAppHtml5Canvas methodsFor: 'tags' stamp: 'cwp 9/20/2011 11:21'!
a
	^ self open: (ALAppATag on: self)! !

!ALAppHtml5Canvas methodsFor: 'accessing' stamp: 'cwp 9/19/2011 17:14'!
context
	^ context! !

!ALAppHtml5Canvas methodsFor: 'accessing' stamp: 'cwp 9/20/2011 10:31'!
currentForm
	^ form! !

!ALAppHtml5Canvas methodsFor: 'initialize-release' stamp: 'cwp 9/19/2011 21:39'!
form
	^ self open: (ALAppFormTag on: self)! !

!ALAppHtml5Canvas methodsFor: 'initialize-release' stamp: 'cwp 9/19/2011 17:11'!
initializeWithContext: aContext stream: aWriteStream 
	self initializeWithStream: aWriteStream.
	context := aContext! !

!ALAppHtml5Canvas methodsFor: 'tags' stamp: 'cwp 9/20/2011 00:49'!
input
	^ self open: (ALAppInputTag on: self)! !

!ALAppHtml5Canvas methodsFor: 'forms' stamp: 'cwp 9/28/2011 00:00'!
useForm: aForm during: aBlock
	| tCurrent tStream tStack |
	
	^	[tCurrent := current.
		current := nil.
		tStream := stream.
		stream := (String new: 64) writing.
		tStack := stack.
		stack := OrderedCollection new.
		form := aForm.
		aBlock value.
		self flush.
		stream conclusion] ensure:
			[current := tCurrent.
			stream := tStream.
			stack := tStack.
			form := nil].
	
			! !

ALFormTag subclass: #ALAppFormTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2011 14:34'!
beGet
	self method: 'GET'! !

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2011 14:33'!
bePost
	self method: 'POST'! !

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 22:45'!
with: anObject
	| form html path |
	form := ALForm new.
	html := canvas useForm: form during: [canvas render: anObject].
	path := canvas context registerForm: form.
	self action: path asString.
	super with: [canvas raw: html]
! !

ALResource subclass: #ALHtmlResource
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALHtmlResource class methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 17:00'!
component: aComponent
	^ self basicNew initializeWithContent: aComponent! !

!ALHtmlResource class methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 17:00'!
content: aComponent
	^ self basicNew initializeWithContent: aComponent! !

!ALHtmlResource methodsFor: 'as yet unclassified' stamp: 'cwp 10/1/2011 16:30'!
handleGet: aRequest locator: aLocator

	| context utf8 |
	^ ALResponse
		type: ALContentType html
		callback:
			[:out |
			utf8 := out encoding: #utf8.
			context := (ALRenderingContext resource: self locator: aLocator).
			content renderOn: (ALAppHtml5Canvas context: context stream: utf8)]
! !

!ALHtmlResource methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 17:00'!
initializeWithContent: anObject
	content := anObject  ! !
